##
## SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
## Copyright (c) 2023-2025 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
## SPDX-License-Identifier: LicenseRef-NvidiaProprietary
##
## NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
## property and proprietary rights in and to this material, related
## documentation and any modifications thereto. Any use, reproduction,
## disclosure or distribution of this material and related documentation
## without an express license agreement from NVIDIA CORPORATION or
## its affiliates is strictly prohibited.
##

# These tasks are intended to be run on the host. They translate the
# pcie dev-id to the mst dev-id

- name: Get the pcie device from rshim num
  command: /usr/bin/env python3
  args:
    stdin: |
       import re
       import subprocess
       rshim_num = {{ rshim_num }}
       cmd = f"grep pcie /dev/rshim{rshim_num}/misc"
       output = subprocess.check_output(cmd.split())
       id_pat = re.compile("pcie-0000:(?P<id>\S+)")
       obj = id_pat.search(output.decode())
       if obj:
           pcie_id = obj["id"]
           #replace .2 with .0"
           pcie_id = pcie_id.split(".")[0] + ".0"
       else:
           pcie_id = "blank"
       print(pcie_id)
  register: pcie_id_str

- name: Parse PCI dev id
  set_fact:
    pcie_id: "{{ pcie_id_str.stdout.strip() }}"

- name: Print pcie_id
  debug:
    msg: "{{ pcie_id }}"

- name: Get mst status
  shell: "mst status -v |grep {{ pcie_id }}" # noqa 305
  register: mst_status

- name: Print mst_status
  debug:
    msg: "{{ mst_status.stdout.strip() }}"

- name: Get the mst device from pcie device
  command: /usr/bin/env python3
  args:
    stdin: |
       mst_status = "{{ mst_status.stdout.strip() }}"
       print(mst_status.split()[1])
  register: mst_dev_id_out

- name: Parse mst device id
  set_fact:
    mst_dev_id: "{{ mst_dev_id_out.stdout.strip() }}"

- name: Print mst_dev_id
  debug:
    msg: "{{ mst_dev_id }}"
